unit Palette;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ToolWin, ComCtrls, ImgList, ActnList, Menus, StdActns, ExtActns,
  ExtCtrls, StrUtils;

type
  TForm_Palette = class(TForm)
    P_Menu: TMainMenu;
    P_ActionList: TActionList;
    P_ImageList: TImageList;
    P_ToolBar: TToolBar;
    OpenPicture1: TOpenPicture;
    Files: TMenuItem;
    O1: TMenuItem;
    Button_FOP: TToolButton;
    StatusBar1: TStatusBar;
    ScrollBox1: TScrollBox;
    P_Canvas: TImage;
    Button_VG: TToolButton;
    ToolButton2: TToolButton;
    ViewGrid1: TAction;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure OpenPicture1Accept(Sender: TObject);
    procedure ViewGrid1Execute(Sender: TObject);
    procedure GridLineDraw;
    procedure DrawArea(Sender: TObject; X0, Y0, X1, Y1: Integer);
    procedure P_CanvasMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure P_CanvasMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure P_CanvasMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FreeChip(Sender: TObject);
    procedure _PCursorClear(Sender: TObject);
  private
    { Private 錾 }
    procedure WMEraseBkgnd(var m: TWMEraseBkgnd); message WM_ERASEBKGND;
  public
    { Public 錾 }
  end;

var
  Form_Palette: TForm_Palette;

  CurrentFile : String;

  _PLayer  : Array of TBitmap; // C[`p
  _PGrid   : TBitmap; // Obh`p
  _PCursor : TBitmap; // J[\`p
  _PMoveC  : TBitmap; // ړ̃J[\`p

  _Rect : TRect; // Ɨ̈̎wp

  _ChipX, _ChipY : Integer; // `bvPʂ̃J[\ʒuAĕ`攻p

  _StX, _StY : Integer; // `I̊Jnʒu
  _EdX, _EdY : Integer; // `ȈIʒu

implementation

uses Canvas, Grid;

{$R *.dfm}

procedure TForm_Palette.WMEraseBkgnd(var m: TWMEraseBkgnd);
begin
  m.Result := LRESULT(False); // ĕ`掞̂}鏈B炵B
end; // twvATBitmap ibmpformu.pasj

procedure TForm_Palette.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Form_Canvas.ToolButton2.Down := False; // Form_Canvasɂ\{^𐧌
end;

procedure TForm_Palette.FormCreate(Sender: TObject);
begin
  _PGrid := TBitmap.Create; // Obh\pBitmap
  _PGrid.Transparent := True; // 
  _PGrid.TransparentMode := tmFixed; // Fݒ͎wF


  SetLength(_PLayer, 1); // pBitmap̏ݒ
  _PLayer[0] := TBitmap.Create;

  _PCursor := TBitmap.Create; // J[\\pBitmap

  _ChipX := 0; // `bvPʂ̃J[\ʒu
  _ChipY := 0;
end;

procedure TForm_Palette.OpenPicture1Accept(Sender: TObject);
begin
  CurrentFile := OpenPicture1.Dialog.FileName; // t@Cl
  _PLayer[0].LoadFromFile(CurrentFile); // t@Cǂݍ
  if _PLayer[0].PixelFormat = pf8bit then // pbg8rbg256F̏ꍇ
    _PLayer[0].PixelFormat := pf24bit; // pbg24rbgɕϊȂƃJ[\]\ςɂȂ
  _PLayer[0].Dormant; // GDI \[X
  _PLayer[0].FreeImage; // Memory 

  P_Canvas.Width  := _PLayer[0].Width;  // \ݒ
  P_Canvas.Height := _PLayer[0].Height; // \ݒ

  P_Canvas.Picture.Bitmap.Width  := _PLayer[0].Width;  // \̗̈敝ݒ
  P_Canvas.Picture.Bitmap.Height := _PLayer[0].Height; // \̗̈捂ݒ

  _Rect := Rect(0, 0, _PLayer[0].Width, _PLayer[0].Height); // 摜̈ݒ

  _PGrid.Width  := _PLayer[0].Width;  // Obh`̗̈敝ݒ
  _PGrid.Height := _PLayer[0].Height; // Obh`̗̈捂ݒ
  GridLineDraw; // ObhBitmapɕ`

  _PCursor.Width  := _PLayer[0].Width;  // J[\`̗̈敝ݒ
  _PCursor.Height := _PLayer[0].Height; // J[\`̗̈捂ݒ
  _PCursor.Canvas.CopyMode := cmSrcErase;
  _PCursor.Canvas.CopyRect(_Rect, _PCursor.Canvas, _Rect); // J[\`̈

  ViewGrid1.OnExecute(Sender); // Obh`{^ɏ]ăObh`搧
end;

procedure TForm_Palette.ViewGrid1Execute(Sender: TObject);
begin
// Obh̕\}ƓɁA
// pbgAObhAJ[\摜̍ōsB
//
  P_Canvas.Picture.Assign(_PLayer[0]); // `bv\

  if Button_VG.Down then // Obh`{^Ă
    P_Canvas.Canvas.Draw(0, 0, _PGrid); // Obh㏑

  P_Canvas.Canvas.CopyMode := cmSrcInvert; // [h𔽓]ɂ
  P_Canvas.Canvas.CopyRect(_Rect, _PCursor.Canvas, _Rect); // J[\㏑
end;

procedure TForm_Palette.GridLineDraw;
var
  _GridW, _GridH : Integer;
  _H,  _V  : Integer;
  _x,  _y  : Integer;
  _i       : Integer;

  _PenColor : TColor;
begin
  _PenColor := Form_Grid.ColorPanel.Color; // Obh{Fm

  _GridW := Form_Grid._GridW; // Obhl
  _GridH := Form_Grid._GridH; // Obhl

  with _PGrid do // Obh\̓ꊇ
  begin
    _H := Trunc(Width  / _GridW) + 1; // ̌JԂ 
    _V := Trunc(Height / _GridH) + 1; // ̌JԂ 

    Canvas.Brush.Color := $FFFFFF // ObhFƕKقȂFɂȂ悤
      xor _PenColor; // hԂFObhF̔]F
    Canvas.FillRect(_Rect); // ShԂ
    TransparentColor := Canvas.Brush.Color; // hԂF𓧖FɎw

    Canvas.Pen.Color := _PenColor; // Obh̐Fl
    for _i := 1 to _H do // 
    begin
      _x := _i * _GridW - 1;
      Canvas.MoveTo(_x, 0);
      Canvas.LineTo(_x, Height);
    end;
    for _i := 1 to _V do // 
    begin
      _y := _i * _GridH - 1;
      Canvas.MoveTo(0,     _y);
      Canvas.LineTo(Width, _y);
    end;
  end;
end;

procedure TForm_Palette.DrawArea(Sender: TObject; X0, Y0, X1, Y1: Integer);
var
  _X,  _Y  : Integer;
  _XX, _YY : Integer;
  _GridW, _GridH : Integer;
begin
  if Y1 < Y0 then // I͈͂̏㉺
  begin
    _Y  := Y1;
    _YY := Y0;
  end
  else
  begin
    _Y  := Y0;
    _YY := Y1;
  end;
  if X1 < X0 then // I͈͂̍E
  begin
    _X  := X1;
    _XX := X0;
  end
  else
  begin
    _X  := X0;
    _XX := X1;
  end;
  StatusBar1.Panels[1].Text := // I͈͂̐l\
    IntToStr(_X)  + ', ' + IntToStr(_Y) + ' - ' +
    IntToStr(_XX) + ', ' + IntToStr(_YY);

  _GridW := Form_Grid._GridW; // Obhl
  _GridH := Form_Grid._GridH; // Obhl
  _PCursorClear(Sender);
//  _PCursor.Canvas.CopyMode := cmSrcErase; // J[\摜
//  _PCursor.Canvas.CopyRect(_Rect, _PCursor.Canvas, _Rect);
  _PCursor.Canvas.Pen.Color := clWhite; // I͈͕`
  _PCursor.Canvas.MoveTo( _X       * _GridW + 2,  _Y       * _GridH + 2);
  _PCursor.Canvas.LineTo((_XX + 1) * _GridW - 2,  _Y       * _GridH + 2);
  _PCursor.Canvas.LineTo((_XX + 1) * _GridW - 2, (_YY + 1) * _GridH - 2);
  _PCursor.Canvas.LineTo( _X       * _GridW + 2, (_YY + 1) * _GridH - 2);
  _PCursor.Canvas.LineTo( _X       * _GridW + 2,  _Y       * _GridH + 2);

  ViewGrid1.OnExecute(Sender);
end;

procedure TForm_Palette.P_CanvasMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if ssLeft in Shift then // }EX{^ꂽȂ
  begin
    _StX := X div Form_Grid._GridW; // `bvPʂ̃J[\ʒuZo
    _StY := Y div Form_Grid._GridH;

    DrawArea(Sender, _StX, _StY, _StX, _StY); // I͈͕\
  end
  else if ssRight in Shift then // }EXE{^ꂽȂ
  begin
    FreeChip(Sender); // `bvI\
  end;
end;

procedure TForm_Palette.P_CanvasMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if ssLeft in Shift then // }EX{^ꂽȂ
  begin
    _EdX := X div Form_Grid._GridW; // `bvPʂ̃J[\ʒuZo
    _EdY := Y div Form_Grid._GridH;

    DrawArea(Sender, _StX, _StY, _EdX, _EdY); // I͈͕\
  end;
end;

procedure TForm_Palette.P_CanvasMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
  _X, _Y: Integer;
begin
  StatusBar1.Panels[0].Text :=
    RightStr('    ' + IntToStr(X), 5) + ',' +
    RightStr('    ' + IntToStr(Y), 5); // ݍW\

  _X := X div Form_Grid._GridW; // `bvPʂ̃J[\ʒuZo
  _Y := Y div Form_Grid._GridH;

  if (_ChipX <> _X) or (_ChipY <> _Y) then // `bvPʂ̃J[\ʒu
  begin // ړĂꍇ̂ݍĕ`
    _ChipX := _X; // ݂̃`bvPʃJ[\ʒuύX
    _ChipY := _Y;

    if ssLeft in Shift then // }EX{^Ă
      DrawArea(Sender, _StX, _StY, _X, _Y); // IGA\
  end;
end;

procedure TForm_Palette.FreeChip(Sender: TObject);
begin
  _StX := -1;
  _StY := -1;
  _PCursorClear(Sender);
  ViewGrid1.OnExecute(Sender);
  StatusBar1.Panels[1].Text := ''; // I͈͂̐l\
end;

procedure TForm_Palette._PCursorClear(Sender: TObject);
begin
  _PCursor.Canvas.CopyMode := cmSrcErase; // J[\摜
  _PCursor.Canvas.CopyRect(_Rect, _PCursor.Canvas, _Rect);
end;

end.
